/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the Address type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Address{}

// Address struct for Address
type Address struct {
	Street string `json:"street"`
	HouseNumber string `json:"house_number"`
	DoorNumber string `json:"door_number"`
	Zip string `json:"zip"`
	City string `json:"city"`
	Country string `json:"country"`
	Ortsteil string `json:"ortsteil"`
}

// NewAddress instantiates a new Address object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAddress(street string, houseNumber string, doorNumber string, zip string, city string, country string, ortsteil string) *Address {
	this := Address{}
	this.Street = street
	this.HouseNumber = houseNumber
	this.DoorNumber = doorNumber
	this.Zip = zip
	this.City = city
	this.Country = country
	this.Ortsteil = ortsteil
	return &this
}

// NewAddressWithDefaults instantiates a new Address object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAddressWithDefaults() *Address {
	this := Address{}
	return &this
}

// GetStreet returns the Street field value
func (o *Address) GetStreet() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Street
}

// GetStreetOk returns a tuple with the Street field value
// and a boolean to check if the value has been set.
func (o *Address) GetStreetOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Street, true
}

// SetStreet sets field value
func (o *Address) SetStreet(v string) {
	o.Street = v
}

// GetHouseNumber returns the HouseNumber field value
func (o *Address) GetHouseNumber() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.HouseNumber
}

// GetHouseNumberOk returns a tuple with the HouseNumber field value
// and a boolean to check if the value has been set.
func (o *Address) GetHouseNumberOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.HouseNumber, true
}

// SetHouseNumber sets field value
func (o *Address) SetHouseNumber(v string) {
	o.HouseNumber = v
}

// GetDoorNumber returns the DoorNumber field value
func (o *Address) GetDoorNumber() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DoorNumber
}

// GetDoorNumberOk returns a tuple with the DoorNumber field value
// and a boolean to check if the value has been set.
func (o *Address) GetDoorNumberOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DoorNumber, true
}

// SetDoorNumber sets field value
func (o *Address) SetDoorNumber(v string) {
	o.DoorNumber = v
}

// GetZip returns the Zip field value
func (o *Address) GetZip() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Zip
}

// GetZipOk returns a tuple with the Zip field value
// and a boolean to check if the value has been set.
func (o *Address) GetZipOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Zip, true
}

// SetZip sets field value
func (o *Address) SetZip(v string) {
	o.Zip = v
}

// GetCity returns the City field value
func (o *Address) GetCity() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.City
}

// GetCityOk returns a tuple with the City field value
// and a boolean to check if the value has been set.
func (o *Address) GetCityOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.City, true
}

// SetCity sets field value
func (o *Address) SetCity(v string) {
	o.City = v
}

// GetCountry returns the Country field value
func (o *Address) GetCountry() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Country
}

// GetCountryOk returns a tuple with the Country field value
// and a boolean to check if the value has been set.
func (o *Address) GetCountryOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Country, true
}

// SetCountry sets field value
func (o *Address) SetCountry(v string) {
	o.Country = v
}

// GetOrtsteil returns the Ortsteil field value
func (o *Address) GetOrtsteil() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Ortsteil
}

// GetOrtsteilOk returns a tuple with the Ortsteil field value
// and a boolean to check if the value has been set.
func (o *Address) GetOrtsteilOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Ortsteil, true
}

// SetOrtsteil sets field value
func (o *Address) SetOrtsteil(v string) {
	o.Ortsteil = v
}

func (o Address) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Address) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["street"] = o.Street
	toSerialize["house_number"] = o.HouseNumber
	toSerialize["door_number"] = o.DoorNumber
	toSerialize["zip"] = o.Zip
	toSerialize["city"] = o.City
	toSerialize["country"] = o.Country
	toSerialize["ortsteil"] = o.Ortsteil
	return toSerialize, nil
}

type NullableAddress struct {
	value *Address
	isSet bool
}

func (v NullableAddress) Get() *Address {
	return v.value
}

func (v *NullableAddress) Set(val *Address) {
	v.value = val
	v.isSet = true
}

func (v NullableAddress) IsSet() bool {
	return v.isSet
}

func (v *NullableAddress) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAddress(val *Address) *NullableAddress {
	return &NullableAddress{value: val, isSet: true}
}

func (v NullableAddress) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAddress) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


